"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdatedAttachmentTemplateSpec = exports.UpdatedAttachmentSpec = exports.CreatedAttachmentSpec = exports.AttachmentsSpec = exports.AttachmentSpec = exports.UpdatedBugTemplateSpec = exports.UpdatedBugSpec = exports.CreatedBugSpec = exports.CreatedCommentSpec = exports.CommentsSpec = exports.CommentsTemplateSpec = exports.CommentSpec = exports.HistoryLookupSpec = exports.BugHistorySpec = exports.HistorySpec = exports.ChangeSpec = exports.BugSpec = exports.FlagSpec = exports.UpdateFlagSpec = exports.SetFlagSpec = exports.UserSpec = exports.VersionSpec = exports.LoginResponseSpec = void 0;
const validators_1 = require("./validators");
exports.LoginResponseSpec = {
    id: validators_1.int,
    token: validators_1.string,
};
exports.VersionSpec = {
    version: validators_1.string,
};
exports.UserSpec = {
    id: validators_1.int,
    name: validators_1.string,
    real_name: validators_1.string,
};
exports.SetFlagSpec = {
    status: validators_1.string,
    name: (0, validators_1.optional)(validators_1.string),
    type_id: (0, validators_1.optional)(validators_1.int),
    requestee: (0, validators_1.optional)(validators_1.string),
};
exports.UpdateFlagSpec = {
    ...exports.SetFlagSpec,
    id: (0, validators_1.optional)(validators_1.int),
    new: (0, validators_1.optional)(validators_1.boolean),
};
exports.FlagSpec = {
    ...exports.SetFlagSpec,
    id: validators_1.int,
    creation_date: validators_1.datetime,
    modification_date: validators_1.datetime,
    setter: validators_1.string,
};
exports.BugSpec = {
    alias: (0, validators_1.nullable)((0, validators_1.maybeArray)(validators_1.string), []),
    assigned_to: validators_1.string,
    assigned_to_detail: (0, validators_1.object)(exports.UserSpec),
    blocks: (0, validators_1.array)(validators_1.int),
    cc: (0, validators_1.array)(validators_1.string),
    cc_detail: (0, validators_1.array)((0, validators_1.object)(exports.UserSpec)),
    classification: validators_1.string,
    component: (0, validators_1.maybeArray)(validators_1.string),
    creation_time: validators_1.datetime,
    creator: validators_1.string,
    creator_detail: (0, validators_1.object)(exports.UserSpec),
    depends_on: (0, validators_1.array)(validators_1.int),
    dupe_of: (0, validators_1.nullable)(validators_1.int),
    flags: (0, validators_1.optional)((0, validators_1.array)((0, validators_1.object)(exports.FlagSpec))),
    groups: (0, validators_1.array)(validators_1.string),
    id: validators_1.int,
    is_cc_accessible: validators_1.boolean,
    is_confirmed: validators_1.boolean,
    is_open: validators_1.boolean,
    is_creator_accessible: validators_1.boolean,
    keywords: (0, validators_1.array)(validators_1.string),
    last_change_time: validators_1.datetime,
    op_sys: validators_1.string,
    platform: validators_1.string,
    priority: validators_1.string,
    product: validators_1.string,
    qa_contact: validators_1.string,
    qa_contact_detail: (0, validators_1.optional)((0, validators_1.object)(exports.UserSpec)),
    resolution: validators_1.string,
    see_also: (0, validators_1.optional)((0, validators_1.array)(validators_1.string)),
    severity: validators_1.string,
    status: validators_1.string,
    summary: validators_1.string,
    target_milestone: validators_1.string,
    update_token: (0, validators_1.optional)(validators_1.string),
    url: validators_1.string,
    version: (0, validators_1.maybeArray)(validators_1.string),
    whiteboard: validators_1.string,
};
exports.ChangeSpec = {
    field_name: validators_1.string,
    removed: validators_1.string,
    added: validators_1.string,
    attachment_id: (0, validators_1.optional)(validators_1.int),
};
exports.HistorySpec = {
    when: validators_1.datetime,
    who: validators_1.string,
    changes: (0, validators_1.array)((0, validators_1.object)(exports.ChangeSpec)),
};
exports.BugHistorySpec = {
    id: validators_1.int,
    alias: (0, validators_1.array)(validators_1.string),
    history: (0, validators_1.array)((0, validators_1.object)(exports.HistorySpec)),
};
exports.HistoryLookupSpec = {
    bugs: (0, validators_1.array)((0, validators_1.object)(exports.BugHistorySpec)),
};
exports.CommentSpec = {
    attachment_id: (0, validators_1.nullable)((0, validators_1.optional)(validators_1.int)),
    bug_id: validators_1.int,
    count: validators_1.int,
    creation_time: validators_1.datetime,
    creator: validators_1.string,
    id: validators_1.int,
    is_private: validators_1.boolean,
    tags: (0, validators_1.array)(validators_1.string),
    time: validators_1.datetime,
    text: validators_1.string,
};
exports.CommentsTemplateSpec = {
    comments: (0, validators_1.array)((0, validators_1.object)(exports.CommentSpec)),
};
exports.CommentsSpec = {
    bugs: (0, validators_1.map)(validators_1.intString, (0, validators_1.object)(exports.CommentsTemplateSpec)),
    comments: (0, validators_1.map)(validators_1.intString, (0, validators_1.object)(exports.CommentSpec)),
};
exports.CreatedCommentSpec = {
    id: validators_1.int,
};
exports.CreatedBugSpec = {
    id: validators_1.int,
};
const ChangesSpec = {
    added: validators_1.string,
    removed: validators_1.string,
};
exports.UpdatedBugSpec = {
    id: validators_1.int,
    alias: (0, validators_1.array)(validators_1.string),
    last_change_time: validators_1.datetime,
    changes: (0, validators_1.map)(validators_1.string, (0, validators_1.object)(ChangesSpec)),
};
exports.UpdatedBugTemplateSpec = {
    bugs: (0, validators_1.array)((0, validators_1.object)(exports.UpdatedBugSpec)),
};
exports.AttachmentSpec = {
    data: validators_1.base64,
    size: validators_1.int,
    creation_time: validators_1.datetime,
    last_change_time: validators_1.datetime,
    id: validators_1.int,
    bug_id: validators_1.int,
    file_name: validators_1.string,
    summary: validators_1.string,
    content_type: validators_1.string,
    is_private: validators_1.boolean,
    is_obsolete: validators_1.boolean,
    is_patch: validators_1.boolean,
    creator: validators_1.string,
    flags: (0, validators_1.array)((0, validators_1.object)(exports.FlagSpec)),
};
exports.AttachmentsSpec = {
    bugs: (0, validators_1.map)(validators_1.intString, (0, validators_1.array)((0, validators_1.object)(exports.AttachmentSpec))),
    attachments: (0, validators_1.map)(validators_1.intString, (0, validators_1.object)(exports.AttachmentSpec)),
};
exports.CreatedAttachmentSpec = {
    ids: (0, validators_1.array)(validators_1.int),
};
exports.UpdatedAttachmentSpec = {
    id: validators_1.int,
    last_change_time: validators_1.datetime,
    changes: (0, validators_1.map)(validators_1.string, (0, validators_1.object)(ChangesSpec)),
};
exports.UpdatedAttachmentTemplateSpec = {
    attachments: (0, validators_1.array)((0, validators_1.object)(exports.UpdatedAttachmentSpec)),
};
//# sourceMappingURL=types.js.map